         
         #include <avr/interrupt.h>        //          
         #define Ind_Port PORTB
         #define Ind_DDR  DDRB
         #define Ind_PIN  PINB
         #define RW 1
         #define RS 0
         #define E  2 
         volatile unsigned char BitDeistle;                       
     //***************************//
       //    LCD
     //***************************//  
    void  LCD_display (void)
     {         
          static unsigned char  Initialization,error;        		
         //**********************// 
           //   BS 
         //**********************//                                   
          if (BitDeistle & (1<<7))      // 7   1 ( )
            {
              Ind_DDR = 0b00001111;
              Ind_Port = 0b11110000 |(1<<RW);
              asm("nop");
              Ind_Port |= (1<<E);
              asm("nop");
              asm("nop");
              if (Ind_PIN&(1<<7)) 
                {
                  Ind_Port &=~ (1<<E);
                  asm("nop");
                  asm("nop");
                  Ind_Port |= (1<<E);
                  asm("nop");
                  asm("nop");
				  Ind_Port = 0;
                  Ind_DDR = 0b11111111;				               			  
				  return;                        						                             
                }				
			  error = 0;
              BitDeistle &=~ (1<<7);   //p                                                                    
              Ind_Port = 0;
              Ind_DDR = 0b11111111;
            } 
          //***********************// 
               // LCD
          //***********************//                                   
          if (!(BitDeistle &(1<<0)))   //()                                        
             {  
			   Initialization++;       		  
               switch (Initialization )
                 {
                   case 4: COMMAND_IND (0b00101000);break; //   
                   case 5: COMMAND_IND (0b00001000);break; //                                                                                      
                   case 6: COMMAND_IND (0b00000001);break; //                     
                   case 7: COMMAND_IND (0b00000110);break; //    
                   case 8:
                     COMMAND_IND (0b00001111);             
                     BitDeistle |= (1<<0);
                     OCR0 =  OCR0 >> 2;                    //   
                     break;  
				//===============//	          
                   default:  				                                                             
                     Ind_Port = 0b00110000;
                     asm("nop");                
                     Ind_Port |= (1<<E);
                     asm("nop");
                     asm("nop");
                     asm("nop"); 
					 Ind_Port &=~ (1<<E);			
                     break;
                 } 
			  return;                                                                                                                                                    
           } 		  		  			                 
    }        
    //*************************//                                                                              
    //    // 
    //*************************//                                               
   void DATA_IND (char Date)
    {		                                       
        Ind_Port = Date &~ ((1<<E)|(1<<RW)|(1<<3));   
        Ind_Port |= (1<<RS);
        asm("nop"); 
        asm("nop");
        Ind_Port |= (1<<E);                         
        BitDeistle |= (1<<7); 
        asm("nop"); 
	    asm("nop"); 		                               
        Ind_Port &=~ (1<<E);                       
        Ind_Port = (1<<RS) | (16 * (Date & (0b00001111)));           
        Ind_Port |= (1<<E);                          
        asm("nop");
        asm("nop");	                   
	    Ind_Port &=~ (1<<E);
		Ind_Port |=(1<<RW)|(1<<RS);                           
     }                                                          
    //****************************//
       //     
    //****************************//
    void COMMAND_IND (char Date)
     {                           
        Ind_Port = Date &~ ((1<<E)|(1<<RS)|(1<<RW)|(1<<3)); 
        asm("nop");
        asm("nop");               
        Ind_Port |= (1<<E); 
		BitDeistle |= (1<<7);                                           
        asm("nop");
        asm("nop"); 
	    Ind_Port &=~ (1<<E);                              
        Ind_Port=16 * (Date & (0b00001111));        
        Ind_Port |=( 1<<E);                        
        asm("nop");
        asm("nop");
        asm("nop");
	    Ind_Port &=~ (1<<E);                   
	    Ind_Port |=(1<<RW)|(1<<RS);
     }
   

 
 



